{{
        SPeechIN Demo
        Jonathan "lonesock" Dummer

        not yet working, of course [8^)
}}

CON
  ' clock info
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  ' display info
  tiles    = vga#xtiles * vga#ytiles
  tiles32  = tiles * 32  
  lines_per_bucket = vga#ytiles * 32 / speech#NumBuckets
  first_bucket_to_render = 1

  ' typical Demo Board values
  adc_drive_pin   = 9
  adc_monitor_pin = 8

OBJ
  vga: "VGA_512x384_Bitmap"
  term: "HDS"
  speech: "SPeechIN"

VAR
  long  energy_buckets[speech#NumBuckets + speech#WordLen]
  long  sync, pixels[tiles32]
  word  colors[tiles]

  long last_formant
  
PUB yeehaw | x, y, p, t, rnd, last_val, scale_down, dclocks, timeout, smooth_it, zz
  ' just a simple demo of the thing in action
  
  ' now start my Pseudo-Walsh transform
  longfill( @energy_buckets, 0, speech#NumBuckets )
  speech.start( adc_drive_pin, adc_monitor_pin, @energy_buckets )

  ' serial in
  term.start( 31, 30, 250_000 )

  ' VGA out  
  vga.start(16, @colors, @pixels, @sync)  
  
  ' set up the colors
  p~
  repeat y from 0 to vga#ytiles - 1
    repeat x from 0 to vga#xtiles - 1
      t := 1 + (((x * 24) >> 6) <# 2)
      t := ((t << 6) | (t << 4) | (t << 2)) << 8
      colors[p++] := t | (((y ^ x) & 1) << 2)

  reset_display
  
  scale_down~
  smooth_it~
  repeat    
    ' check for user input
    p := term.rxtime( 1 )
    case p
      "w": ' word signature
        term.str( string( "f1,f2,f2_ratio,sib_ratio", 13 ) )
        repeat y from speech#NumBuckets to speech#NumBuckets + speech#WordLen - 1
          p := energy_buckets[y]
          repeat 4
            p <-= 8
            term.dec( p & $FF )
            term.tx( "," )
          term.tx( 13 )                               
      "r": ' reset
        reset_display
      "s": ' smoothing (cheap, display only, also looks bad ;-)
        smooth_it := 2 - smooth_it
      "f": ' send formant info
        p := energy_buckets[0]
        repeat 4
          p <-= 8
          term.dec( p & $FF )
          term.tx( "," )
        term.dec( p )
        term.tx( 13 )
      "d": ' dump formant and energy info
        p := energy_buckets[0]
        repeat 4
          p <-= 8
          term.dec( p & $FF )
          term.tx( "," )
        term.tx( 13 )
        term.str( string( "bucket,energy", 13 ) )
        repeat y from 1 to speech#NumBuckets-1
          term.dec( y )
          term.tx( "," )
          term.dec( ||energy_buckets[y] )
          term.tx( 13 )
        
    ' display it
    p~
    repeat y from first_bucket_to_render to speech#NumBuckets-1
      p #>= ||energy_buckets[y]
    p >>= scale_down
    repeat while p > 255
      p >>= 1
      ++scale_down
    p := @pixels
    'repeat while not sync
    t~
    x~
    repeat y from first_bucket_to_render to speech#NumBuckets-1
      x += (||energy_buckets[y] - x) ~> smooth_it      
      t := (x >> scale_down) <# 255 #> 0
      rnd := t >> 5
      t := |<(t - (rnd << 5)) - 1
      repeat lines_per_bucket
        longfill( p, 0, 8 )
        longfill( p, $FFFFFFFF, rnd )
        long[p][rnd] := t
        p += constant( 16 * 4 )
    ' represent the F1,F2 formants
    update_formant( energy_buckets[0] )
    ' draw the last word's signature
    p := @pixels + (256*vga#xtiles + (vga#xtiles>>1)) * 4
    t := 256
    repeat y from speech#NumBuckets to (speech#NumBuckets + speech#WordLen - 1)
      zz~
      repeat 4
        longfill( p, zz, 8 )
        rnd := energy_buckets[y]
        repeat x from 256 to 448 step 64
          rnd <-= 8
          plot( x + ((rnd & 255) >> 2), t ) 
        p += constant( vga#xtiles << 2 )
        t += 1
        zz ^= 1
      

PRI update_formant( new_f )
  unplot( 256 + (last_formant >> 24) & 255, (last_formant >> 16) & 255 )
  last_formant := new_f
  plot( 256 + (last_formant >> 24) & 255, (last_formant >> 16) & 255 )  

PRI reset_display | x
  last_formant := 513
  longfill( @pixels, 0, tiles32 )
  repeat x from 0 to 255
    plot( x+256, 0 )
    plot( x+256, 255 )
    plot( 256, x )
    plot( 511, x )

PRI plot(x,y)' | i
  'if x => 0 and x < 512 and y => 0 and y < 384
    pixels[y << 4 + x >> 5] |= |< x

PRI unplot(x,y)' | i
  'if x => 0 and x < 512 and y => 0 and y < 384
    pixels[y << 4 + x >> 5] &= !(|< x) 